Package: TreeAndLeaf
Type: Package
Title: Displaying binary trees with focus on dendrogram leaves
Version: 1.22.0
Description: The TreeAndLeaf package combines unrooted and force-directed graph algorithms in order to layout binary trees, aiming to represent multiple layers of information onto dendrogram leaves.
Author: Leonardo W. Kume, Luis E. A. Rizzardi, Milena A. Cardoso, Mauro A. A. Castro
Maintainer: Milena A. Cardoso <milenandreuzo@gmail.com>
Depends: R(>= 4.0)
Imports: RedeR(>= 1.40.4), igraph, ape
Suggests: knitr, rmarkdown, BiocStyle, RUnit, BiocGenerics, stringr,
        geneplast, ggtree, ggplot2, dplyr, dendextend, RColorBrewer
License: Artistic-2.0
Encoding: UTF-8
RoxygenNote: 7.1.1
VignetteBuilder: knitr
biocViews: Infrastructure, GraphAndNetwork, Software, Network,
        Visualization, DataRepresentation
NeedsCompilation: no
Packaged: 2025-10-30 07:00:45 UTC; biocbuild
git_url: https://git.bioconductor.org/packages/TreeAndLeaf
git_branch: RELEASE_3_22
git_last_commit: 1198a67
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29

# TreeAndLeaf 
An R package for displaying binary trees, aiming to represent multiple layers of information on dendrogram leaves.

## Installation
Install TreeAndLeaf from github:

```{r}
if (! requireNamespace("devtools", quietly = TRUE))
install.packages("devtools")
devtools::install_github("sysbiolab/TreeAndLeaf", force = TRUE, build_vignettes = TRUE)
```

For more info on how to use the package:

```{r}
vignette("TreeAndLeaf")
```

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>"
)

## ----eval=TRUE, message=FALSE-------------------------------------------------
#-- Libraries required in this section:
#-- TreeAndLeaf(>=1.4.2), RedeR(>=1.40.4), Bioconductor >= 3.13 (R >= 4.0)
# BiocManager::install(c("TreeAndLeaf","RedeR"))
# install.packages(c("igraph","RColorBrewer"))

#-- Load packages
library("TreeAndLeaf")
library("RedeR")
library("igraph")
library("RColorBrewer")

## ----eval=TRUE, message=FALSE-------------------------------------------------
#-- Check data
dim(USArrests)
head(USArrests)

## ----eval=TRUE, message=FALSE-------------------------------------------------
hc <- hclust(dist(USArrests), "ave")
plot(hc, main="Dendrogram for the 'USArrests' dataset",
     xlab="", sub="")

## ----eval=FALSE---------------------------------------------------------------
# #-- Convert the 'hclust' object into a 'tree-and-leaf' object
# tal <- treeAndLeaf(hc)

## ----eval=FALSE---------------------------------------------------------------
# #--- Map attributes to the tree-and-leaf
# #Note: 'refcol = 0' indicates that 'dat' rownames will be used as mapping IDs
# tal <- att.mapv(g = tal, dat = USArrests, refcol = 0)

## ----eval=FALSE---------------------------------------------------------------
# #--- Set graph attributes using the 'att.setv' wrapper function
# pal <- brewer.pal(9, "Reds")
# tal <- att.setv(g = tal, from = "Murder", to = "nodeColor",
#                 cols = pal, nquant = 5)
# tal <- att.setv(g = tal, from = "UrbanPop", to = "nodeSize",
#                 xlim = c(10, 50, 5), nquant = 5)
# 
# #--- Set graph attributes using 'att.addv' and 'att.adde' functions
# tal <- att.addv(tal, "nodeFontSize", value = 15, index = V(tal)$isLeaf)
# tal <- att.adde(tal, "edgeWidth", value = 3)

## ----eval=FALSE---------------------------------------------------------------
# #--- Call RedeR application
# rdp <- RedPort()
# calld(rdp)
# resetd(rdp)

## ----eval=FALSE---------------------------------------------------------------
# #--- Send the tree-and-leaf to the interactive R/Java interface
# addGraph(obj = rdp, g = tal, gzoom=75)
# 
# #--- Call 'relax' to fine-tune the leaf nodes
# relax(rdp, p1=25, p2=200, p3=5, p5=5, ps=TRUE)

## ----eval=FALSE---------------------------------------------------------------
# #--- Add legends
# addLegend.color(obj = rdp, tal, title = "Murder Rate",
#                 position = "topright")
# addLegend.size(obj = rdp, tal, title = "Urban Population Size",
#                position = "bottomright")

## ----eval=FALSE, message=FALSE------------------------------------------------
# #-- Libraries required in this section:
# #-- TreeAndLeaf(>=1.4.2), RedeR(>=1.40.4), Bioconductor >= 3.13 (R >= 4.0)
# # BiocManager::install(c("TreeAndLeaf","RedeR","ggtree))
# # install.packages(c("igraph","ape", "dendextend", "dplyr",
# #                    "ggplot2", "RColorBrewer"))
# 
# #-- Load packages
# library("TreeAndLeaf")
# library("RedeR")
# library("igraph")
# library("ape")
# library("ggtree")
# library("dendextend")
# library("dplyr")
# library("ggplot2")
# library("RColorBrewer")

## ----eval=FALSE---------------------------------------------------------------
# #--- Generate a random phylo tree
# phylo_tree <- rcoal(300)
# 
# #--- Set groups and node sizes
# group <- size <- dendextend::cutree(phylo_tree, 10)
# group[] <- LETTERS[1:10][group]
# size[] <- sample(size)
# group.df <- data.frame(label=names(group), group=group, size=size)
# phylo_tree <- dplyr::full_join(phylo_tree, group.df, by='label')
# 
# #--- Generate a ggtree with 'daylight' layout
# pal <- brewer.pal(10, "Set3")
# ggt <- ggtree(phylo_tree, layout = 'daylight', branch.length='none')
# 
# #--- Plot the ggtree
# ggt + geom_tippoint(aes(color=group, size=size)) +
#   scale_color_manual(values=pal) + scale_y_reverse()

## ----eval=FALSE---------------------------------------------------------------
# #-- Convert the 'ggtree' object into a 'tree-and-leaf' object
# tal <- treeAndLeaf(ggt)
# 
# #--- Map attributes to the tree-and-leaf
# #Note: 'refcol = 1' indicates that 'dat' col 1 will be used as mapping IDs
# tal <- att.mapv(g = tal, dat = group.df, refcol = 1)
# 
# #--- Set graph attributes using the 'att.setv' wrapper function
# tal <- att.setv(g = tal, from = "group", to = "nodeColor",
#                 cols = pal)
# tal <- att.setv(g = tal, from = "size", to = "nodeSize",
#                 xlim = c(10, 50, 5))
# 
# #--- Set graph attributes using 'att.addv' and 'att.adde' functions
# tal <- att.addv(tal, "nodeFontSize", value = 1)
# tal <- att.addv(tal, "nodeLineWidth", value = 0)
# tal <- att.addv(tal, "nodeColor", value = "black", index=!V(tal)$isLeaf)
# tal <- att.adde(tal, "edgeWidth", value = 3)
# tal <- att.adde(tal, "edgeColor", value = "black")

## ----eval=FALSE---------------------------------------------------------------
# #--- Call RedeR application
# rdp <- RedPort()
# calld(rdp)
# resetd(rdp)

## ----eval=FALSE---------------------------------------------------------------
# #--- Send the tree-and-leaf to the interactive R/Java interface
# addGraph(obj = rdp, g = tal, gzoom=50)
# 
# #--- Select inner nodes, preventing them from relaxing
# selectNodes(rdp, V(tal)$name[!V(tal)$isLeaf], anchor=TRUE)
# 
# #--- Call 'relax' to fine-tune the leaf nodes
# relax(rdp, p1=25, p2=100, p3=5, p5=1, p8=5, ps=TRUE)
# 
# #--- Add legends
# addLegend.color(obj = rdp, tal, title = "Group",
#                 position = "topright",vertical=T)
# addLegend.size(obj = rdp, tal, title = "Size",
#                position = "topleft",
#                vertical=T, dxtitle=10)

## ----eval=FALSE, message=FALSE------------------------------------------------
# #-- Libraries required in this section:
# #-- TreeAndLeaf(>=1.4.2), RedeR(>=1.40.4), Bioconductor >= 3.13 (R >= 4.0)
# # BiocManager::install(c("TreeAndLeaf","RedeR"))
# # install.packages(c("igraph", "RColorBrewer"))
# 
# #-- Load packages
# library(TreeAndLeaf)
# library(RedeR)
# library(igraph)
# library(RColorBrewer)

## ----echo=TRUE----------------------------------------------------------------
#-- Check data
dim(quakes)
head(quakes)

## ----eval=TRUE, message=FALSE-------------------------------------------------
#-- Building a large dendrogram
hc <- hclust(dist(quakes), "ave")
plot(hc, main="Dendrogram for the 'quakes' dataset",
     xlab="", sub="")

## ----eval=FALSE---------------------------------------------------------------
# #-- Convert the 'hclust' object into a 'tree-and-leaf' object
# tal <- treeAndLeaf(hc)

## ----eval=FALSE---------------------------------------------------------------
# #--- Map attributes to the tree-and-leaf
# #Note: 'refcol = 0' indicates that 'dat' rownames will be used as mapping IDs
# tal <- att.mapv(tal, quakes, refcol = 0)
# 
# #--- Set graph attributes using the 'att.setv' wrapper function
# pal <- brewer.pal(9, "Greens")
# tal <- att.setv(g = tal, from = "mag", to = "nodeColor",
#                 cols = pal, nquant = 10)
# tal <- att.setv(g = tal, from = "depth", to = "nodeSize",
#                 xlim = c(40, 120, 20), nquant = 5)
# 
# #--- Set graph attributes using 'att.addv' and 'att.adde' functions
# tal <- att.addv(tal, "nodeFontSize", value = 1)
# tal <- att.adde(tal, "edgeWidth", value = 10)

## ----eval=FALSE---------------------------------------------------------------
# #--- Call RedeR application
# rdp <- RedPort()
# calld(rdp)
# resetd(rdp)

## ----eval=FALSE---------------------------------------------------------------
# #--- Send the tree-and-leaf to the interactive R/Java interface
# addGraph(obj = rdp, g = tal, gzoom=10)
# 
# #--- Call 'relax' to fine-tune the leaf nodes
# relax(rdp, p1=25, p2=200, p3=10, p4=100, p5=10, ps=TRUE)

## ----eval=FALSE---------------------------------------------------------------
# #--- Add legends
# addLegend.color(obj = rdp, tal, title = "Richter Magnitude",
#                 position = "bottomright")
# addLegend.size(obj = rdp, tal, title = "Depth (km)")

## ----eval=TRUE, message=FALSE-------------------------------------------------
#-- Libraries required in this section:
#-- TreeAndLeaf(>=1.4.2), RedeR(>=1.40.4), Bioconductor >= 3.13 (R >= 4.0)
# BiocManager::install(c("TreeAndLeaf","RedeR","geneplast))
# install.packages(c("igraph","ape", "RColorBrewer"))

#-- Load packages
library(TreeAndLeaf)
library(RedeR)
library(igraph)
library(ape)
library(geneplast)
library(RColorBrewer)

## ----eval=TRUE, message=FALSE-------------------------------------------------
#-- Load data and plot the phylogenetic tree
data("spdata")
data("gpdata.gs")
plot(phyloTree)

## ----eval=FALSE---------------------------------------------------------------
# #--- Drop organisms not listed in the 'spdata' annotation
# phyloTree$tip.label <- as.character(phyloTree$tip.label)
# tokeep <- phyloTree$tip.label %in% spdata$tax_id
# pruned.phylo <- drop.tip(phyloTree, phyloTree$tip.label[!tokeep])

## ----eval=FALSE---------------------------------------------------------------
# #-- Convert the phylogenetic tree into a 'tree-and-leaf' object
# tal <- treeAndLeaf(pruned.phylo)
# 
# #--- Map attributes to the tree-and-leaf
# #Note: 'refcol = 1' indicates that 'dat' col 1 will be used as mapping IDs
# tal <- att.mapv(g = tal, dat = spdata, refcol = 1)
# 
# #--- Set graph attributes using the 'att.setv' wrapper function
# pal <- brewer.pal(9, "Purples")
# tal <- att.setv(g = tal, from = "genome_size_Mb",
#                 to = "nodeSize", xlim = c(120, 250, 1), nquant = 5)
# tal <- att.setv (g = tal, from = "proteins",
#                  to = "nodeColor", nquant = 5,
#                  cols = pal, na.col = "black")

## ----eval=FALSE---------------------------------------------------------------
# #--- Add graph attributes using 'att.adde' and 'att.addv' functions
# tal <- att.addv(tal, "nodeFontSize", value = 10)
# tal <- att.adde(tal, "edgeWidth", value = 20)
# 
# # Set species names to 'nodeAlias' attribute
# tal <- att.setv(tal, from = "sp_name", to = "nodeAlias")
# 
# # Select a few names to highlight in the graph
# tal <- att.addv(tal, "nodeFontSize", value = 100,
#        filter=list('name'=sample(pruned.phylo$tip.label,30)))
# tal <- att.addv(tal, "nodeFontSize", value = 100,
#                 filter=list('name'="9606")) #Homo sapiens

## ----eval=FALSE---------------------------------------------------------------
# # Call RedeR
# rdp <- RedPort()
# calld(rdp)
# resetd(rdp)
# 
# #--- Send the tree-and-leaf to the interactive R/Java interface
# addGraph(obj = rdp, g = tal, gzoom=10)
# 
# #--- Call 'relax' to fine-tune the leaf nodes
# relax(rdp, ps=TRUE)

## ----eval=FALSE---------------------------------------------------------------
# #--- Add legends
# addLegend.color(rdp, tal, title = "Proteome Size (n)")
# addLegend.size(rdp, tal, title = "Genome Size (Mb)")

## ----eval=FALSE---------------------------------------------------------------
# #-- Libraries required in this section:
# #-- TreeAndLeaf(>=1.4.2), RedeR(>=1.40.4), Bioconductor >= 3.13 (R >= 4.0)
# # BiocManager::install(c("TreeAndLeaf","RedeR","geneplast))
# # install.packages(c("igraph","ape", "RColorBrewer"))
# 
# #-- Load packages
# library(TreeAndLeaf)
# library(RedeR)
# library(igraph)
# library(ape)
# library(geneplast)
# library(RColorBrewer)

## ----eval=FALSE, message=FALSE------------------------------------------------
# #-- Load data
# data("spdata")
# data("phylo_tree")

## ----eval=FALSE, message=FALSE------------------------------------------------
# #--- Drop organisms not listed in the 'spdata' annotation
# tokeep <- phylo_tree$tip.label %in% spdata$tax_id
# pruned.phylo <- drop.tip(phylo_tree, phylo_tree$tip.label[!tokeep])

## ----eval=FALSE---------------------------------------------------------------
# #-- Convert the phylogenetic tree into a 'tree-and-leaf' object
# tal <- treeAndLeaf(pruned.phylo)

## ----eval=FALSE---------------------------------------------------------------
# #--- Map attributes to the tree-and-leaf using "%>%" operator
# tal <- tal %>%
#   att.mapv(dat = spdata, refcol = 1) %>%
#   att.setv(from = "genome_size_Mb", to = "nodeSize",
#            xlim = c(120, 250, 1), nquant = 5) %>%
#   att.setv(from = "proteins", to = "nodeColor", nquant = 5,
#            cols = brewer.pal(9, "Blues"), na.col = "black") %>%
#   att.setv(from = "sp_name", to = "nodeAlias") %>%
#   att.adde(to = "edgeWidth", value = 20) %>%
#   att.addv(to = "nodeFontSize", value = 10) %>%
#   att.addv(to = "nodeFontSize", value = 100,
#       filter = list("name" = sample(pruned.phylo$tip.label, 30))) %>%
#   att.addv(to = "nodeFontSize", value = 100,
#            filter = list("name" = "9606"))

## ----eval=FALSE---------------------------------------------------------------
# # Call RedeR
# rdp <- RedPort()
# calld(rdp)
# resetd(rdp)
# 
# #--- Send the tree-and-leaf to the interactive R/Java interface
# addGraph(obj = rdp, g = tal, gzoom=5)
# 
# #--- Call 'relax' to fine-tune the leaf nodes
# relax(rdp, ps=TRUE)

## ----eval=FALSE---------------------------------------------------------------
# #--- Add legends
# addLegend.color(rdp, tal, title = "Proteome Size (n)")
# addLegend.size(rdp, tal, title = "Genome size (Mb)")

## ----label='Session information', eval=TRUE, echo=FALSE-----------------------
sessionInfo()

#' Layout a TreeAndLeaf diagram.
#'
#' This function tranforms hclust and phylo objects into tree-and-leaf 
#' igraph objects.
#'
#' @param obj An object of class 'hclust' or 'phylo'.
#' 
#' @return A tree-and-leaf igraph object.
#'
#' @seealso \code{\link{formatTree}}
#' @seealso \code{\link[stats:hclust]{hclust}}
#' @seealso \code{\link[ape:as.phylo]{as.phylo}}
#' @seealso \code{\link[RedeR:addGraph]{addGraph}}
#' @seealso \code{\link[RedeR:relax]{relax}}
#'
#' @examples
#' library(RedeR)
#' rdp <- RedPort()
#' hc <- hclust(dist(USArrests), "ave")
#' tal <- treeAndLeaf(hc)
#' 
#' \dontrun{
#' calld(rdp)
#' addGraph(obj=rdp, tal)
#' }
#'
#' @importFrom igraph edge_betweenness is.igraph V E 'V<-' 'E<-' 
#' @importFrom ape as.phylo as.igraph.phylo
#' @importFrom RedeR RedPort
#' @export

treeAndLeaf <- function(obj){
    tal.checks(name="obj", para=obj)
    tal <- .setTaL(obj)
    return(tal)
}
# resetd(rdp)
# addGraph(rdp, tal)
#-------------------------------------------------------------------------------
.setTaL <- function(obj){
    if ("hclust" %in% class(obj)){
        phylo <- ape::as.phylo(obj)
        gg <- ape::as.igraph.phylo(phylo, directed=FALSE)
        coords <- .get.tree.coords(phylo, use.edge.length=FALSE)
    } else if("phylo" %in% class(obj)){
        gg <- ape::as.igraph.phylo(obj, directed=FALSE)
        coords <- .get.tree.coords(obj, use.edge.length=FALSE)
    } else if("ggtree" %in% class(obj)){
        lpar <- obj$layers[[1]]$stat_params$layout
        vpar <- c("daylight","ape","fan","equal_angle")
        if(!lpar%in%vpar)
            stop("Please, use one of the 'ggtree' layouts: ",
                 paste0(vpar, collapse = ", "),"!", call.=FALSE)
        # gdata <- ggplot_build(obj)$data[[1]]
        phylo <- ape::as.phylo(obj$data)
        gg <- ape::as.igraph.phylo(phylo, directed=FALSE)
        coords <- .get.tree.coords(phylo, use.edge.length=FALSE)
        coords$layout[,] <- as.matrix(obj$data[,c("x","y")])
    }
    if(!all(V(gg)$name%in%rownames(coords$layout)))
        stop("An unexpected error occurred while transforming the graph object!")
    #--- set layout
    layout <- coords$layout[V(gg)$name,]
    V(gg)$coordX <- layout[,"x"]
    V(gg)$coordY <- layout[,"y"]
    V(gg)$isLeaf <- V(gg)$name%in%coords$phylo$tip.label
    gg$centralVertex <- coords$centralVertex
    #--- set edge weights
    E(gg)$weight <- 0.01
    bt <- igraph::edge_betweenness(gg, directed = T)
    bt <- (1 - bt/max(bt))
    E(gg)$weight <- bt
    #--- set node and font sizes
    V(gg)$nodeAlias <- V(gg)$name
    V(gg)$nodeSize <- 5
    V(gg)$nodeSize[V(gg)$isLeaf] <- 30
    V(gg)$nodeFontSize <- 15
    V(gg)$nodeFontSize[!V(gg)$isLeaf] <- 1
    V(gg)$nodeColor <- "#ffcccc"
    V(gg)$nodeLineColor <- "#9999ff"
    V(gg)$nodeLineWidth <- 2
    E(gg)$edgeColor <- "#9999ff"
    E(gg)$edgeWidth <- 2
    #--- set zoom
    sz <- sum(V(gg)$isLeaf)
    sz <- sqrt(sz)
    # gg$zoom <- ceiling(max(0,100-sz))
    gg$gtype <- "TreeAndLeaf"
    class(gg) <- c("tal","igraph")
    return(gg)
}

#-------------------------------------------------------------------------------
# This function gets coordinates from an unrooted 'phylo' objects,
# derived from a currectly not exported function from the ape package
.get.tree.coords <- function(phy, use.edge.length = FALSE){
    if (is.null(phy$edge.length)) use.edge.length <- FALSE
    phy <- ape::reorder.phylo(phy)
    Ntip <- length(phy$tip.label)
    Nedge <- dim(phy$edge)[1]
    Nnode <- phy$Nnode
    nb.sp <- ape::node.depth(phy)
    XY <- if(use.edge.length){
        .unrooted.xy(Ntip, Nnode, phy$edge, phy$edge.length, nb.sp)
    } else {
        .unrooted.xy(Ntip, Nnode, phy$edge, rep(1, Nedge), nb.sp)
    }
    xx <- XY$M[, 1] - min(XY$M[, 1])
    yy <- XY$M[, 2] - min(XY$M[, 2])
    layout <- cbind(x=xx,y=yy)
    if(is.null(phy$node.label)) phy <- ape::makeNodeLabel(phy)
    if(anyDuplicated(c(phy$tip.label, phy$node.label))) 
        stop("Duplicated labels!")
    rownames(layout) <- c(phy$tip.label,phy$node.label)
    centralVertex <- phy$node.label[1]
    return(list(phylo=phy, layout=layout,centralVertex=centralVertex))
}

#-------------------------------------------------------------------------------
# This function gets coordinates from an unrooted 'phylo' objects,
# derived from a currectly not exported function from the ape package
.unrooted.xy <- function(Ntip, Nnode, edge, edge.length, nb.sp){
    foo <- function(node, ANGLE, AXIS) {
        ind <- which(edge[, 1] == node)
        sons <- edge[ind, 2]
        start <- AXIS - ANGLE/2
        for (i in 1:length(sons)) {
            h <- edge.length[ind[i]]
            angle[sons[i]] <<- alpha <- ANGLE*nb.sp[sons[i]]/nb.sp[node]
            axis[sons[i]] <<- beta <- start + alpha/2
            start <- start + alpha
            xx[sons[i]] <<- h*cos(beta) + xx[node]
            yy[sons[i]] <<- h*sin(beta) + yy[node]
        }
        for (i in sons)
            if (i > Ntip) foo(i, angle[i], axis[i])
    }
    Nedge <- dim(edge)[1]
    yy <- xx <- numeric(Ntip + Nnode)
    axis <- angle <- numeric(Ntip + Nnode)
    foo(Ntip + 1L, 2*pi, 0)
    M <- cbind(xx, yy)
    axe <- axis[1:Ntip]
    axeGTpi <- axe > pi
    axe[axeGTpi] <- axe[axeGTpi] - 2*pi
    list(M = M, axe = axe)
}

#' Genome statistics for eukaryotes with complete genome sequence
#'
#' Data from the NCBI Genome Database for eukaryotes with complete genome sequence.
#' The list of organisms were obtained from the KEGG Organisms Database, and
#' taxonomy IDs were obtained from the NCBI Taxonomy Database.
#' 
#' @docType data
#'
#' @name spdata
#'
#' @usage data(spdata)
#'
#' @format An object of class \code{"data.frame"}
#'
#' @keywords datasets
#'
#' @references
#' NCBI Genome Database
#' https://www.ncbi.nlm.nih.gov/genome
#' Accessed: August 15, 2019.
#' 
#' NCBI Taxonomy Database
#' https://www.ncbi.nlm.nih.gov/taxonomy
#' Accessed: August 15, 2019.
#' 
#' KEGG Organisms Database
#' https://www.genome.jp/kegg/catalog/org_list.html
#' Accessed: August 15, 2019.
#'
#' @examples
#' data(spdata)
NULL

#' Species tree from STRING-db v11
#'
#' A phylo object for the species tree available from the STRING-db v11.
#' 
#' @docType data
#' 
#' @name phylo_tree
#'
#' @usage data(phylo_tree)
#' 
#' @format An object of class \code{"phylo"}
#'
#' @keywords phylotree
#'
#' @references 
#' Szklarczyk D. et al. STRING v11: protein-protein association networks with 
#' increased coverage, supporting functional discovery in genome-wide 
#' experimental datasets. Nucleic Acids Res. 47:D607-613, 2019.

#' 
NULL

#' Species metadata from STRING-db v11
#'
#' Species metadata used in a phylo object.
#' 
#' @docType data
#' 
#' @name phylo_species
#'
#' @usage data(phylo_species)
#' 
#' @format An object of class \code{"data.frame"}
#'
#' @keywords datasets
#'
#' @references 
#' Szklarczyk D. et al. STRING v11: protein-protein association networks with 
#' increased coverage, supporting functional discovery in genome-wide 
#' experimental datasets. Nucleic Acids Res. 47:D607-613, 2019.
#' 
NULL

##This function is used for argument checking
tal.checks <- function(name, para){
    if(identical(name, "tal")) {
        if(!is.tal(para)){
            stop("'tal' must be an 'igraph' object created by the 
                 TreeAndLeaf() function!", call.=FALSE)
        }
    } else if(identical(name, "theme")){
        if(!is.singleInteger(para) || para > 5 || para < 1){
            stop("'theme' must be an integer ranging from 1 to 5!", 
                    call.=FALSE)
        }
    } else if(identical(name, "obj")){
        if (!any(class(para)%in%c("hclust","phylo","ggtree")))
            stop("'obj' must be a 'hclust', 'phylo', or 'ggtree' objects!", 
                 call.=FALSE)
    } else {
        stop("'name' option not available!", call.=FALSE)
    }
}

##------------------------------------------------------------------------------
is.tal <- function(para){
    "tal" %in% class(para)
}
is.singleInteger <- function(para){
    lg <- (is.integer(para) || is.numeric(para)) && length(para)==1L && 
        !is.na(para)
    if(lg) lg <- (para / ceiling(para)) == 1
    return(lg)
}
is.singleString <- function(para){
    is.character(para) && length(para) == 1L && !is.na(para)
}
is.singleLogical <- function(para){
    is.logical(para) && length(para) == 1L && !is.na(para)
}

#' A theme function for tree-and-leaf igraph objects.
#'
#' This function sets attributes of a tree-and-leaf igraph object for
#' plotting in the RedeR app interface.
#' 
#' @param tal An igraph object generated by the \code{\link{TreeAndLeaf}} function.
#' @param theme An integer ranging from 1 to 5 with desired theme. \cr
#' Options: \cr
#' 1- A clean black and blue theme, for additional customizations. \cr
#' 2- Green palette theme. \cr
#' 3- Blue palette theme. \cr
#' 4- Purple palette theme. \cr
#' 5- Red palette theme. \cr
#' For detailed customization, see attributes in the 
#' \code{\link[RedeR]{addGraph}} method. \cr
#' 
#' @return An igraph object with attributes for RedeR application.
#'
#' @seealso \code{\link[RedeR]{addGraph}}
#' @seealso \code{\link{treeAndLeaf}}
#'
#' @examples
#' library(RedeR)
#' hc <- hclust(dist(USArrests), "ave")
#' tal <- treeAndLeaf(hc)
#' tal <- formatTree(tal, theme = 5)
#'
#' @importFrom igraph V E  
#' @export

formatTree <- function(tal, theme = 1){
    tal.checks(name = "tal", para = tal)
    tal.checks(name = "theme", para = theme)
    tal <- .setSizeTheme(tal)
    tal <- .setColorTheme(tal, theme)
    return(tal)
}
#-------------------------------------------------------------------------------
.setSizeTheme <- function(tal){
    sz <- sum(V(tal)$isLeaf)
    sz <- sqrt(sz)
    igraph::V(tal)$nodeFontSize <- ceiling(min(max(15,sz),75))
    igraph::V(tal)$nodeFontSize[!V(tal)$isLeaf] <- 1
    igraph::V(tal)$nodeSize <- ceiling(min(max(15,sz),100))
    igraph::V(tal)$nodeSize[!V(tal)$isLeaf] <- ceiling(min(max(5,sz/6),15))
    igraph::E(tal)$edgeWidth <- ceiling(min(max(15,sz/2),50))
    igraph::V(tal)$nodeLineWidth  <- ceiling(min(max(5,sz/2),20))
    return(tal)
}
#-------------------------------------------------------------------------------
.setColorTheme <- function(tal, theme){
    #Set node line color
    switch (theme,
            igraph::V(tal)$nodeLineColor <- "#000000",
            igraph::V(tal)$nodeLineColor <- "#379683",
            igraph::V(tal)$nodeLineColor <- "#55CFD1",
            igraph::V(tal)$nodeLineColor <- "#7F61A5",
            igraph::V(tal)$nodeLineColor <- "#D4A59A")
    #Set node font color
    switch (theme,
            igraph::V(tal)$nodeFontColor <- "#000000",
            igraph::V(tal)$nodeFontColor <- "#05386B",
            igraph::V(tal)$nodeFontColor <- "#1F2833",
            igraph::V(tal)$nodeFontColor <- "#5C2018",
            igraph::V(tal)$nodeFontColor <- "#5C2018")
    #Set the edge color
    switch (theme,
            igraph::E(tal)$edgeColor <- "#000000",
            igraph::E(tal)$edgeColor <- "#379683",
            igraph::E(tal)$edgeColor <- "#55CFD1",
            igraph::E(tal)$edgeColor <- "#7F61A5",
            igraph::E(tal)$edgeColor <- "#D4A59A")
    #Set the node colors
    switch (theme,
            igraph::V(tal)$nodeColor <- "#190061",
            igraph::V(tal)$nodeColor <- "#5CDB95",
            igraph::V(tal)$nodeColor <- "#45A29E",
            igraph::V(tal)$nodeColor <- "#44318D",
            igraph::V(tal)$nodeColor <- "#BC4639")
    return(tal)
}

test_tal <- function(){
    hc <- hclust(dist(USArrests), "average")
    tal <- treeAndLeaf(hc)
    RUnit::checkTrue(is(tal, "igraph"))
    RUnit::checkTrue(!is.null(tal$gtype))
    RUnit::checkTrue(tal$gtype=="TreeAndLeaf")
}
test_theme<- function(){
    hc <- hclust(dist(USArrests), "average")
    tal <- treeAndLeaf(hc)
    tal <- formatTree(tal, theme = 5)
    RUnit::checkTrue(is(tal, "igraph"))
    RUnit::checkTrue(!is.null(tal$gtype))
    RUnit::checkTrue(tal$gtype=="TreeAndLeaf")
}

---
title: '*TreeAndLeaf*: A graph layout strategy for binary trees with focus on the leaves'
author: 'Milena A Cardoso, Luis E A Rizzardi, Leonardo W Kume, Sheyla Trefflich, Clarice Groeneveld, Mauro A A Castro'
date: "`r BiocStyle::doc_date()`"
abstract: "The **TreeAndLeaf** package combines tree and force-directed layout algorithms for drawing binary trees, aiming to represent multiple layers of information onto the leaves."
package: "`r BiocStyle::pkg_ver('TreeAndLeaf')`"
output:
    BiocStyle::html_document:
        css: custom.css
vignette: >
  %\VignetteIndexEntry{TreeAndLeaf: an graph layout to dendrograms.}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>"
)
```

# Overview

A dendrogram diagram displays binary trees focused on representing 
hierarchical relations between the tree elements. A dendrogram contains 
nodes, branches (edges), a root, and leaves (**Figure 1A**). The root is where 
the branches and nodes come from, indicating the direction to the leaves, 
*i.e.*, the terminal nodes.

Most of the space of a dendrogram layout is used to arrange branches and inner 
nodes, with limited space to the leaves. For large dendrograms, the leaf 
labels are often squeezed to fit into small slots. Therefore, a dendrogram 
may not provide the best layout when the information to be displayed should 
highlight the leaves.

The **TreeAndLeaf** package aims to improve the visualization of the dendrogram 
leaves by combining tree and force-directed layout algorithms, shifting the 
focus of analysis to the leaves (**Figure 1B**). The package's workflow is 
summarized in **Figure 1C**.

<p align="center">
<img width="1000" src="overview.png">
</p>
**Figure 1**. **TreeAndLeaf** workflow summary. **(A,B)** The dendrogram in A 
is used to construct the graph in B. **(C)** The main input for the **TreeAndLeaf** 
package consists of a dendrogram, and then the package transforms the dendrogram 
into a graph representation. The finest graph layout is achieved by a two-steps 
process, starting with an unrooted tree diagram, which is subsequently relaxed 
by a force-directed algorithm applied to the terminal nodes of the tree. The 
final *tree-and-leaf* layout varies depending on the initial state, which can be 
obtained by other tree layout algorithms (see *section 3* for examples using 
*ggtree* layouts to setup the initial state).

# Quick Start

This section provides a basic example using the R built-in `USArrests` dataset. 
The `USArrests` is a dataframe available in the user's workspace. To know more 
about this dataframe, please query `?USArrests` in the R console. We will build 
a dendrogram from the `USArrests` dataset, then transform the dendrogram into 
a *tree-and-leaf* diagram, and the result will be visualized in the **RedeR** 
application.

## Package and data requirements

```{r, eval=TRUE, message=FALSE}
#-- Libraries required in this section:
#-- TreeAndLeaf(>=1.4.2), RedeR(>=1.40.4), Bioconductor >= 3.13 (R >= 4.0)
# BiocManager::install(c("TreeAndLeaf","RedeR"))
# install.packages(c("igraph","RColorBrewer"))

#-- Load packages
library("TreeAndLeaf")
library("RedeR")
library("igraph")
library("RColorBrewer")
```

```{r, eval=TRUE, message=FALSE}
#-- Check data
dim(USArrests)
head(USArrests)
```

## Building a dendrogram example

In order to build a dendrogram from the `USArrests` dataset, we need a distance 
matrix. We will use the default "euclidean distance" method from the `dist()` 
function, and then the "average" method from `hclust()` function to create the 
dendrogram.

```{r, eval=TRUE, message=FALSE}
hc <- hclust(dist(USArrests), "ave")
plot(hc, main="Dendrogram for the 'USArrests' dataset",
     xlab="", sub="")
```

## Converting the *hclust* object into a *tree-and-leaf* object

The `treeAndLeaf` function will transform the *hclust* into an *igraph* object,
including some basic graph attributes to display in the **RedeR** application.

```{r, eval=FALSE}
#-- Convert the 'hclust' object into a 'tree-and-leaf' object
tal <- treeAndLeaf(hc)
```

## Setting graph attributes

The `att.mapv()` function can be used to add external annotations to an *igraph* 
object, for example, mapping new variables to the graph vertices. We will add 
all `USArrests` variables to the `tal` object. To map one object to another 
it is essential to use the same mapping IDs, set by the `refcol` parameter, 
which points to a column in the input annotation dataset. In this example, 
`refcol = 0` indicates that the `USArrests` rownames will be used as 
mapping IDs. To check the IDs in the *igraph* vertices, please type 
`V(tal)$name` in the R console.

```{r, eval=FALSE}
#--- Map attributes to the tree-and-leaf
#Note: 'refcol = 0' indicates that 'dat' rownames will be used as mapping IDs
tal <- att.mapv(g = tal, dat = USArrests, refcol = 0)
```

Now we use the `att.setv()` wrapper function to set attributes in the 
*tree-and-leaf* diagram. To see all attributes available to display in the 
**RedeR** application, please type `?addGraph` in the R console. The graph
attributes can also be customized following **igraph** syntax rules.

```{r, eval=FALSE}
#--- Set graph attributes using the 'att.setv' wrapper function
pal <- brewer.pal(9, "Reds")
tal <- att.setv(g = tal, from = "Murder", to = "nodeColor", 
                cols = pal, nquant = 5)
tal <- att.setv(g = tal, from = "UrbanPop", to = "nodeSize",
                xlim = c(10, 50, 5), nquant = 5)

#--- Set graph attributes using 'att.addv' and 'att.adde' functions
tal <- att.addv(tal, "nodeFontSize", value = 15, index = V(tal)$isLeaf)
tal <- att.adde(tal, "edgeWidth", value = 3)
```

## Plotting a *tree-and-leaf* diagram

The next steps will call the **RedeR** application, and then display the 
*tree-and-leaf* diagram in an interactive R/Java interface. The initial layout
will show an unrooted tree diagram, which will be subsequently relaxed by a 
force-directed algorithm applied to the terminal nodes of the tree.

```{r, eval=FALSE}
#--- Call RedeR application
rdp <- RedPort()
calld(rdp)
resetd(rdp)
```

```{r, eval=FALSE}
#--- Send the tree-and-leaf to the interactive R/Java interface
addGraph(obj = rdp, g = tal, gzoom=75)

#--- Call 'relax' to fine-tune the leaf nodes
relax(rdp, p1=25, p2=200, p3=5, p5=5, ps=TRUE)
```

At this point, the user can interact with the layout process to achieve the 
best or desired layout; we suggest fine-tuning the force-directed algorithm 
parameters, either through the R/Java interface or the command line relaxation 
function. Note that the unroot tree diagram represents the initial state; then 
a relaxing process should start until the finest graph layout is achieved. 
The final layout varies depending on the initial state, which can also be 
adjusted by providing more or less room for the spatial configuration 
(*e.g.* via `gzoom` parameter).

```{r, eval=FALSE}
#--- Add legends
addLegend.color(obj = rdp, tal, title = "Murder Rate", 
                position = "topright")
addLegend.size(obj = rdp, tal, title = "Urban Population Size",
               position = "bottomright")
```

<p align="center">
<img height="300" src="USAReds.png">
</p>

# Setting the initial *tree-and-leaf* state with *ggtree* layouts

The tree diagram represents the initial state of a *tree-and-leaf*, which is then 
relaxed by a force-directed algorithm applied to the terminal nodes. Therefore,
the final *tree-and-leaf* layout varies depending on the initial state. The
**treeAndLeaf** package also accepts `ggtree` layouts to setup the initial state. 
For example, next we show a tree diagram generated by the **ggtree** package,
and then we apply the *tree-and-leaf* transformation.

## Package and data requirements

```{r, eval=FALSE, message=FALSE}
#-- Libraries required in this section:
#-- TreeAndLeaf(>=1.4.2), RedeR(>=1.40.4), Bioconductor >= 3.13 (R >= 4.0)
# BiocManager::install(c("TreeAndLeaf","RedeR","ggtree))
# install.packages(c("igraph","ape", "dendextend", "dplyr", 
#                    "ggplot2", "RColorBrewer"))

#-- Load packages
library("TreeAndLeaf")
library("RedeR")
library("igraph")
library("ape")
library("ggtree")
library("dendextend")
library("dplyr")
library("ggplot2")
library("RColorBrewer")
```

## Building and plotting a *phylo* tree with *ggtree* layouts

```{r, eval=FALSE}
#--- Generate a random phylo tree
phylo_tree <- rcoal(300)

#--- Set groups and node sizes
group <- size <- dendextend::cutree(phylo_tree, 10)
group[] <- LETTERS[1:10][group]
size[] <- sample(size)
group.df <- data.frame(label=names(group), group=group, size=size)
phylo_tree <- dplyr::full_join(phylo_tree, group.df, by='label')

#--- Generate a ggtree with 'daylight' layout
pal <- brewer.pal(10, "Set3")
ggt <- ggtree(phylo_tree, layout = 'daylight', branch.length='none')

#--- Plot the ggtree
ggt + geom_tippoint(aes(color=group, size=size)) +
  scale_color_manual(values=pal) + scale_y_reverse()
```

## Applying *tree-and-leaf* transformation to *ggtree* layouts

```{r, eval=FALSE}
#-- Convert the 'ggtree' object into a 'tree-and-leaf' object
tal <- treeAndLeaf(ggt)

#--- Map attributes to the tree-and-leaf
#Note: 'refcol = 1' indicates that 'dat' col 1 will be used as mapping IDs
tal <- att.mapv(g = tal, dat = group.df, refcol = 1)

#--- Set graph attributes using the 'att.setv' wrapper function
tal <- att.setv(g = tal, from = "group", to = "nodeColor",
                cols = pal)
tal <- att.setv(g = tal, from = "size", to = "nodeSize",
                xlim = c(10, 50, 5))

#--- Set graph attributes using 'att.addv' and 'att.adde' functions
tal <- att.addv(tal, "nodeFontSize", value = 1)
tal <- att.addv(tal, "nodeLineWidth", value = 0)
tal <- att.addv(tal, "nodeColor", value = "black", index=!V(tal)$isLeaf)
tal <- att.adde(tal, "edgeWidth", value = 3)
tal <- att.adde(tal, "edgeColor", value = "black")
```

```{r, eval=FALSE}
#--- Call RedeR application
rdp <- RedPort()
calld(rdp)
resetd(rdp)
```

```{r, eval=FALSE}
#--- Send the tree-and-leaf to the interactive R/Java interface
addGraph(obj = rdp, g = tal, gzoom=50)

#--- Select inner nodes, preventing them from relaxing
selectNodes(rdp, V(tal)$name[!V(tal)$isLeaf], anchor=TRUE)

#--- Call 'relax' to fine-tune the leaf nodes
relax(rdp, p1=25, p2=100, p3=5, p5=1, p8=5, ps=TRUE)

#--- Add legends
addLegend.color(obj = rdp, tal, title = "Group", 
                position = "topright",vertical=T)
addLegend.size(obj = rdp, tal, title = "Size", 
               position = "topleft", 
               vertical=T, dxtitle=10)
```

<p align="center">
<img height="350" src="ggtree_tal.png">
</p>

# Case Study 1: visualizing a large dendrogram

## Context

This section follows the same steps described in the *Quick Start*, but 
using a larger dendrogram derived from the R built-in `quakes` dataset. 
The `quakes` is a dataframe available in the user's workspace. To know more 
about this dataframe, please query `?quakes` in the R console. 
We will build a dendrogram from the `quakes` dataset, then transform the 
dendrogram into a *tree-and-leaf* diagram, and the result will be visualized 
in the **RedeR** application.

## Package and data requirements

```{r, eval=FALSE, message=FALSE}
#-- Libraries required in this section:
#-- TreeAndLeaf(>=1.4.2), RedeR(>=1.40.4), Bioconductor >= 3.13 (R >= 4.0)
# BiocManager::install(c("TreeAndLeaf","RedeR"))
# install.packages(c("igraph", "RColorBrewer"))

#-- Load packages
library(TreeAndLeaf)
library(RedeR)
library(igraph)
library(RColorBrewer)
```

```{r echo=TRUE}
#-- Check data
dim(quakes)
head(quakes)
```

```{r, eval=TRUE, message=FALSE}
#-- Building a large dendrogram
hc <- hclust(dist(quakes), "ave")
plot(hc, main="Dendrogram for the 'quakes' dataset",
     xlab="", sub="")
```

## Building and plotting a large *tree-and-leaf* diagram

```{r, eval=FALSE}
#-- Convert the 'hclust' object into a 'tree-and-leaf' object
tal <- treeAndLeaf(hc)
```

```{r, eval=FALSE}
#--- Map attributes to the tree-and-leaf
#Note: 'refcol = 0' indicates that 'dat' rownames will be used as mapping IDs
tal <- att.mapv(tal, quakes, refcol = 0)

#--- Set graph attributes using the 'att.setv' wrapper function
pal <- brewer.pal(9, "Greens")
tal <- att.setv(g = tal, from = "mag", to = "nodeColor",
                cols = pal, nquant = 10)
tal <- att.setv(g = tal, from = "depth", to = "nodeSize",
                xlim = c(40, 120, 20), nquant = 5)

#--- Set graph attributes using 'att.addv' and 'att.adde' functions
tal <- att.addv(tal, "nodeFontSize", value = 1)
tal <- att.adde(tal, "edgeWidth", value = 10)
```

The next steps will call the **RedeR** application, and then display the 
*tree-and-leaf* diagram in an interactive R/Java interface. The initial layout
will show an unrooted tree diagram, which will be subsequently relaxed by a 
force-directed algorithm applied to the terminal nodes of the tree.

```{r, eval=FALSE}
#--- Call RedeR application
rdp <- RedPort()
calld(rdp)
resetd(rdp)
```

```{r, eval=FALSE}
#--- Send the tree-and-leaf to the interactive R/Java interface
addGraph(obj = rdp, g = tal, gzoom=10)

#--- Call 'relax' to fine-tune the leaf nodes
relax(rdp, p1=25, p2=200, p3=10, p4=100, p5=10, ps=TRUE)
```

```{r, eval=FALSE}
#--- Add legends
addLegend.color(obj = rdp, tal, title = "Richter Magnitude",
                position = "bottomright")
addLegend.size(obj = rdp, tal, title = "Depth (km)")
```

<p align="center">
<img height="400" src="QuakesTree.png">
</p>

# Case Study 2: visualizing a phylogenetic tree

## Context

This section generates a *tree-and-leaf* diagram from a pre-computed `phylo` 
tree object. We will use a phylogenetic tree listing 121 eukaryotes, available 
from the **geneplast** package.

## Package and data requirements

```{r, eval=TRUE, message=FALSE}
#-- Libraries required in this section:
#-- TreeAndLeaf(>=1.4.2), RedeR(>=1.40.4), Bioconductor >= 3.13 (R >= 4.0)
# BiocManager::install(c("TreeAndLeaf","RedeR","geneplast))
# install.packages(c("igraph","ape", "RColorBrewer"))

#-- Load packages
library(TreeAndLeaf)
library(RedeR)
library(igraph)
library(ape)
library(geneplast)
library(RColorBrewer)
```

```{r, eval=TRUE, message=FALSE}
#-- Load data and plot the phylogenetic tree
data("spdata")
data("gpdata.gs")
plot(phyloTree)
```

## Building and plotting a *tree-and-leaf* from a phylogenetic tree

```{r, eval=FALSE}
#--- Drop organisms not listed in the 'spdata' annotation
phyloTree$tip.label <- as.character(phyloTree$tip.label)
tokeep <- phyloTree$tip.label %in% spdata$tax_id
pruned.phylo <- drop.tip(phyloTree, phyloTree$tip.label[!tokeep])
```

```{r, eval=FALSE}
#-- Convert the phylogenetic tree into a 'tree-and-leaf' object
tal <- treeAndLeaf(pruned.phylo)

#--- Map attributes to the tree-and-leaf
#Note: 'refcol = 1' indicates that 'dat' col 1 will be used as mapping IDs
tal <- att.mapv(g = tal, dat = spdata, refcol = 1)

#--- Set graph attributes using the 'att.setv' wrapper function
pal <- brewer.pal(9, "Purples")
tal <- att.setv(g = tal, from = "genome_size_Mb",
                to = "nodeSize", xlim = c(120, 250, 1), nquant = 5)
tal <- att.setv (g = tal, from = "proteins",
                 to = "nodeColor", nquant = 5,
                 cols = pal, na.col = "black")
```

```{r, eval=FALSE}
#--- Add graph attributes using 'att.adde' and 'att.addv' functions
tal <- att.addv(tal, "nodeFontSize", value = 10)
tal <- att.adde(tal, "edgeWidth", value = 20)

# Set species names to 'nodeAlias' attribute
tal <- att.setv(tal, from = "sp_name", to = "nodeAlias")

# Select a few names to highlight in the graph
tal <- att.addv(tal, "nodeFontSize", value = 100, 
       filter=list('name'=sample(pruned.phylo$tip.label,30)))
tal <- att.addv(tal, "nodeFontSize", value = 100, 
                filter=list('name'="9606")) #Homo sapiens
```

```{r, eval=FALSE}
# Call RedeR
rdp <- RedPort()
calld(rdp)
resetd(rdp)

#--- Send the tree-and-leaf to the interactive R/Java interface
addGraph(obj = rdp, g = tal, gzoom=10)

#--- Call 'relax' to fine-tune the leaf nodes
relax(rdp, ps=TRUE)
```

```{r, eval=FALSE}
#--- Add legends
addLegend.color(rdp, tal, title = "Proteome Size (n)")
addLegend.size(rdp, tal, title = "Genome Size (Mb)")
```

<p align="center">
<img height="400" src="PhyloPurple.png">
</p>

# Case Study 3: visualizing a non-binary tree

## Context

The **TreeAndLeaf** package is designed to layout binary trees, but it can also
layout other graph configurations. To exemplify this case, we will use a 
larger phylogenetic tree available from the **geneplast** package, and for 
which some inner nodes have more than two children, or non-binary nodes.

## Package and data requirements

```{r, eval=FALSE}
#-- Libraries required in this section:
#-- TreeAndLeaf(>=1.4.2), RedeR(>=1.40.4), Bioconductor >= 3.13 (R >= 4.0)
# BiocManager::install(c("TreeAndLeaf","RedeR","geneplast))
# install.packages(c("igraph","ape", "RColorBrewer"))

#-- Load packages
library(TreeAndLeaf)
library(RedeR)
library(igraph)
library(ape)
library(geneplast)
library(RColorBrewer)
```

```{r, eval=FALSE, message=FALSE}
#-- Load data 
data("spdata")
data("phylo_tree")
```

```{r, eval=FALSE, message=FALSE}
#--- Drop organisms not listed in the 'spdata' annotation
tokeep <- phylo_tree$tip.label %in% spdata$tax_id
pruned.phylo <- drop.tip(phylo_tree, phylo_tree$tip.label[!tokeep])
```

## Building and plotting a *tree-and-leaf* for a non-binary tree

```{r, eval=FALSE}
#-- Convert the phylogenetic tree into a 'tree-and-leaf' object
tal <- treeAndLeaf(pruned.phylo)
```

```{r, eval=FALSE}
#--- Map attributes to the tree-and-leaf using "%>%" operator
tal <- tal %>%
  att.mapv(dat = spdata, refcol = 1) %>%
  att.setv(from = "genome_size_Mb", to = "nodeSize",
           xlim = c(120, 250, 1), nquant = 5) %>%
  att.setv(from = "proteins", to = "nodeColor", nquant = 5,
           cols = brewer.pal(9, "Blues"), na.col = "black") %>%
  att.setv(from = "sp_name", to = "nodeAlias") %>%
  att.adde(to = "edgeWidth", value = 20) %>%
  att.addv(to = "nodeFontSize", value = 10) %>%
  att.addv(to = "nodeFontSize", value = 100,
      filter = list("name" = sample(pruned.phylo$tip.label, 30))) %>%
  att.addv(to = "nodeFontSize", value = 100, 
           filter = list("name" = "9606"))
```

```{r, eval=FALSE}
# Call RedeR
rdp <- RedPort()
calld(rdp)
resetd(rdp)

#--- Send the tree-and-leaf to the interactive R/Java interface
addGraph(obj = rdp, g = tal, gzoom=5)

#--- Call 'relax' to fine-tune the leaf nodes
relax(rdp, ps=TRUE)
```

```{r, eval=FALSE}
#--- Add legends
addLegend.color(rdp, tal, title = "Proteome Size (n)")
addLegend.size(rdp, tal, title = "Genome size (Mb)")
```

<p align="center">
<img width="700" src="nBinPhylo.png">
</p>

# Session information

```{r label='Session information', eval=TRUE, echo=FALSE}
sessionInfo()
```

\name{TreeAndLeaf-package}
\alias{TreeAndLeaf-package}
\alias{TreeAndLeaf}
\docType{package}

\title{
TreeAndLeaf: A graph layout for binary trees with focus on dendrogram leaves.
}

\description{
The TreeAndLeaf package combines unrooted and force-directed graph algorithms 
in order to layout binary trees, aiming to represent multiple layers of 
information onto dendrogram leaves.
}

\details{
\tabular{ll}{
Package: \tab TreeAndLeaf\cr
Type: \tab Package\cr
Depends: \tab R (>= 4.0)\cr 
Imports: \tab RedeR, igraph, ape \cr
Suggests: \tab knitr, rmarkdown, BiocStyle, RUnit, BiocGenerics, stringr,
RColorBrewer\cr 
License: \tab Artistic-2.0\cr
biocViews: \tab NetworkEnrichment, GraphAndNetwork\cr
}
}

\section{Index}{

\tabular{ll}{
\link{formatTree}: \tab A theme function for tree-and-leaf igraph objects.\cr
\link{treeAndLeaf}: \tab Layout a TreeAndLeaf diagram.\cr
}

Further information is available from the vignettes 
\code{vignette("TreeAndLeaf")}.
}

\author{
Leonardo W. Kume, Luis E. A. Rizzardi, Milena A. Cardoso, Mauro A. A. Castro
}

\references{
CASTRO, M. A. et al. RedeR: R/Bioconductor package for representing modular 
structures, nested networks and multiple levels of hierarchical associations.
\strong{Genome Biology}, 13(4):R29, 2012.

CASTRO, M. A. A. et al. Regulators of genetic risk of breast cancer identified 
by integrative network analysis. \strong{Nature Genetics}, 48(1):12–21, 2016.

RUSU, A.; SANTIAGO, C. Grid Drawings of Binary Trees: An Experimental 
Study. \strong{Journal of Graph Algorithms and Applications}, 
12(2):131–195, 2008.
}

\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/formatTree.R
\name{formatTree}
\alias{formatTree}
\title{A theme function for tree-and-leaf igraph objects.}
\usage{
formatTree(tal, theme = 1)
}
\arguments{
\item{tal}{An igraph object generated by the \code{\link{TreeAndLeaf}} function.}

\item{theme}{An integer ranging from 1 to 5 with desired theme. \cr
Options: \cr
1- A clean black and blue theme, for additional customizations. \cr
2- Green palette theme. \cr
3- Blue palette theme. \cr
4- Purple palette theme. \cr
5- Red palette theme. \cr
For detailed customization, see attributes in the 
\code{\link[RedeR]{addGraph}} method. \cr}
}
\value{
An igraph object with attributes for RedeR application.
}
\description{
This function sets attributes of a tree-and-leaf igraph object for
plotting in the RedeR app interface.
}
\examples{
library(RedeR)
hc <- hclust(dist(USArrests), "ave")
tal <- treeAndLeaf(hc)
tal <- formatTree(tal, theme = 5)

}
\seealso{
\code{\link[RedeR]{addGraph}}

\code{\link{treeAndLeaf}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/phylo_tree-data.R
\docType{data}
\name{phylo_tree}
\alias{phylo_tree}
\title{Species tree from STRING-db v11}
\format{
An object of class \code{"phylo"}
}
\usage{
data(phylo_tree)
}
\description{
A phylo object for the species tree available from the STRING-db v11.
}
\references{
Szklarczyk D. et al. STRING v11: protein-protein association networks with 
increased coverage, supporting functional discovery in genome-wide 
experimental datasets. Nucleic Acids Res. 47:D607-613, 2019.
}
\keyword{phylotree}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/spdata-data.R
\docType{data}
\name{spdata}
\alias{spdata}
\title{Genome statistics for eukaryotes with complete genome sequence}
\format{
An object of class \code{"data.frame"}
}
\usage{
data(spdata)
}
\description{
Data from the NCBI Genome Database for eukaryotes with complete genome sequence.
The list of organisms were obtained from the KEGG Organisms Database, and
taxonomy IDs were obtained from the NCBI Taxonomy Database.
}
\examples{
data(spdata)
}
\references{
NCBI Genome Database
https://www.ncbi.nlm.nih.gov/genome
Accessed: August 15, 2019.

NCBI Taxonomy Database
https://www.ncbi.nlm.nih.gov/taxonomy
Accessed: August 15, 2019.

KEGG Organisms Database
https://www.genome.jp/kegg/catalog/org_list.html
Accessed: August 15, 2019.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/treeAndLeaf.R
\name{treeAndLeaf}
\alias{treeAndLeaf}
\title{Layout a TreeAndLeaf diagram.}
\usage{
treeAndLeaf(obj)
}
\arguments{
\item{obj}{An object of class 'hclust' or 'phylo'.}
}
\value{
A tree-and-leaf igraph object.
}
\description{
This function tranforms hclust and phylo objects into tree-and-leaf 
igraph objects.
}
\examples{
library(RedeR)
rdp <- RedPort()
hc <- hclust(dist(USArrests), "ave")
tal <- treeAndLeaf(hc)

\dontrun{
calld(rdp)
addGraph(obj=rdp, tal)
}

}
\seealso{
\code{\link{formatTree}}

\code{\link[stats:hclust]{hclust}}

\code{\link[ape:as.phylo]{as.phylo}}

\code{\link[RedeR:addGraph]{addGraph}}

\code{\link[RedeR:relax]{relax}}
}
